
/**
 * Created by IntelliJ IDEA.
 * Author: Alexandre Koubenski
 *
 *      .
 * :      ,  
 *                .
 * :          
 *                    .
 *
 *  :
 *    -    (n/m)
 *    -         (n)
 *    -    (n*m)
 *
 * Date: 18.12.2005
 * Time: 12:46:13
 */
public class BoyerMoore {
    private static final int shLen = 256;
    private static int hash(char c) { return c & 0xFF; }

    /**
     *   -       ,
     *        
     *      .
     *
     *     -    -1.
     *
     * @param where -  ,   .
     * @param what  - ,  .
     * @return      -    -1
     */
    public static int boyerMoore(String where, String what) {
        int n = where.length();    //   
        int m = what.length();     //  
        //     ,   
        //     0  255,    ,
        //    
        int[] shifts = new int[shLen];
        //  ,   ,    
        for (int i = 0; i < shLen; i++) {
            shifts[i] = m;
        }
        //        
        //        
        for (int i = 0; i < m-1; i++) {
            shifts[hash(what.charAt(i))] = m-i-1;
        }

        for (int i = 0; i <= n-m; ) {
            //     
            for (int j = m-1; j>=0; j--) {
                if (where.charAt(i+j) == what.charAt(j)) {
                    if (j == 0) return i;
                } else {
                    break;
                }
            }
            //          
            i += shifts[hash(where.charAt(i+m-1))];
        }
        return -1;
    }

    /**
     *  :       .
     * @param args
     */
    public static void main(String[] args) {
        int ndx = boyerMoore(Data.strWhere, Data.strWhat);
        if (ndx >= 0) {
            System.out.println("Index found: " + ndx);
            System.out.println("Substring: " + Data.strWhere.substring(ndx, ndx+Data.strWhat.length()));
        } else {
            System.out.println("Substring not found");
        }
    }
}
